
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

; ------ zobrazen vodnho textu

Start:   mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ pprava aktulnho data do zhlav

         mov       ah,2ah
         int       21h                      ; poskytnut systmovho data
         sub       cx,1900
         mov       ds:[Rok],cl              ; rok
         mov       ds:[Mesic],dh            ; msc
         mov       ds:[Den],dl              ; den

; ------ pprava k rozboru pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld

; ------ nalezen zatku jmna souboru

Start1:  jcxz      Start12                  ; nen nic zadno
         mov       dx,si                    ; zatek jmna souboru
         lodsb                              ; naten znaku
         dec       cx                       ; snen tae znak
         cmp       al," "
         je        Start1                   ; oddlovac mezera
         cmp       al,9
         je        Start1
         cmp       al,"?"
         je        Start12
         cmp       al,"*"
         je        Start12
         cmp       al,"/"
         jne       Start2
Start12: mov       dx,offset HelpTxt        ; npovda
         jmp       short Chyba              ; parametr

; ------ nalezen konce jmna souboru

Start2:  mov       di,si                    ; konec jmna souboru
         jcxz      Start3
         lodsb
         dec       cx
         cmp       al," "
         ja        Start2

; ------ koncov teka

Start3:  dec       di
         dec       di
         dec       di
         mov       al,"."
         cmp       byte ptr ds:[di-1],al
         je        Start33
         inc       di
         cmp       byte ptr ds:[di-1],al
         je        Start33
         inc       di
         cmp       byte ptr ds:[di-1],al
         je        Start33
         inc       di
         cmp       byte ptr ds:[di-1],al
         je        Start33
         stosb

; ------ oteven defininho souboru

Start33: mov       word ptr ds:[di],"ED"    ; ppona "DEF"
         mov       word ptr ds:[di+2],"F"
         mov       ax,3d00h
         int       21h                      ; oteven pro ten
         jc        Start4                   ; chyba
         mov       ds:[SoubDef],ax          ; definin soubor

; ------ oteven datovho souboru

Start4:  mov       word ptr ds:[di],"AD"    ; ppona DAT
         mov       word ptr ds:[di+2],"T"
         mov       ax,3d00h
         int       21h                      ; oteven pro zpis
         mov       ds:[SoubDat],ax          ; datov soubor
         jnc       Start5                   ; soubor oteven OK

; ------ zobrazen npovdy

         mov       dx,offset NeniTxt        ; text - nenalezen
Chyba:   mov       ah,9
         int       21h
         int       20h

; ------ test, zda vstupn soubor DBF ji existuje

Start5:  mov       word ptr ds:[di],"BD"
         mov       word ptr ds:[di+2],"F"
         xor       cx,cx                    ; atributy
         mov       ah,4eh
         int       21h                      ; nalezen vstupnho souboru
         jc        Start6
         mov       dx,offset ExistTxt
         jmp       short Chyba

; ------ oteven vstupnho souboru

Start6:  mov       ah,3ch
         xor       cx,cx
         int       21h                      ; vytvoen vstupnho souboru
Start62: mov       dx,offset WritTxt        ; chyba zpisu
         jc        Chyba                    ; chyba vytvoen souboru
         mov       ds:[SoubDbf],ax          ; vstupn soubor

; ------ naten dku nadpisu a masky z defininho souboru

         mov       bx,ds:[SoubDef]          ; definin soubor
         or        bx,bx                    ; soubor oteven ?
         jz        Start7                   ; soubor neoteven
         mov       di,offset Nadpis         ; buffer dku nadpisu
         call      ReadLine                 ; naten dku nadpisu
         mov       di,offset Maska
         call      ReadLine                 ; naten dku masky

; ------ pprava k rozboru poloek

Start7:  mov       si,offset Maska          ; definice masky
         mov       di,offset TabPopis       ; tabulka popisova
         mov       cx,300                   ; poet bajt masky
         cld

; ------ kontrola, zda zbv voln pam k uloen popisovae

Start8:  mov       ax,di                    ; ukldac adresa popisova
         add       ax,32+200h               ; rezerva
         cmp       ax,sp                    ; zbv dost pamti ?
         mov       dx,offset MemTxt         ; chyba pamti
         jae       Chyba                    ; chyba pamti

; ------ jmno poloky

         mov       ax,ds:[JmenPol]          ; jmno poloky
         cmp       ah,"0"
         jne       Start80
         mov       ah,0                     ; korekce
Start80: stosw                              ; jmno poloky
         inc       al
         cmp       al,"Z"
         jbe       Start802
         mov       al,"A"
         inc       ah
Start802:mov       ds:[JmenPol],ax

; ------ inicializace novho popisovae

         push      cx
         mov       cx,(32-2)/2              ; dlka bufferu popisovae
         xor       ax,ax
         rep       stosw                    ; vynulovn popisovae
         pop       cx
         mov       byte ptr ds:[di-32+11],"C" ; znakov poloka

; ------ nalezen zatku masky

         mov       dx,si                    ; zatek masky
         mov       bx,si                    ; konec masky
Start81: jcxz      Start83                  ; konec masky
         mov       dx,si                    ; schova zatku masky
         lodsb                              ; naten znaku
         dec       cx                       ; ta zbylch znak
         cmp       al,"#"
         jne       Start81                  ; nalezen zatku poloky

; ------ nalezen konce masky

Start82: jcxz      Start83                  ; konec masky
         mov       bx,si                    ; konec masky
         lodsb                              ; naten znaku
         dec       cx                       ; ta zbylch znak
         cmp       al,"#"
         je        Start82                  ; nalezen konce masky

; ------ stanoven dlky poloky

Start83: sub       bx,dx                    ; dlka poloky
         jbe       Start88                  ; konec poloek
         or        bh,bh
         jz        Start84
         mov       bx,255
Start84: mov       ds:[di-32+16],bl         ; dlka poloky
         add       ds:[ZaznByte],bx         ; zven tae dlky zznamu
         add       word ptr ds:[HeadByte],32 ; zven velikosti zhlav
         jmp       short Start8             ; dal poloka

; ------ konec masek - zpis zhlav souboru

Start88: sub       di,32
         mov       byte ptr ds:[di],13      ; oznaen konce zhlav
         mov       cx,ds:[HeadByte]         ; velikost zhlav
         mov       bx,ds:[SoubDbf]          ; soubor DBF
         mov       ah,40h
         mov       dx,offset HeadDbf        ; zhlav
         int       21h                      ; zpis zhlav souboru
         jnc       Start89                  ; operace OK
Start882:mov       dx,offset WritTxt
         jmp       Chyba

Start89: cmp       word ptr ds:[ZaznByte],1 ; je njak zznam ?
         jbe       Start882                 ; nen dn zznam

; ------ konverze dat souboru

Start9:  mov       di,offset Zaznam         ; buffer jednoho zznamu
         mov       bx,ds:[SoubDat]          ; datov soubor
         call      ReadLine                 ; naten dku
         jc        Start96                  ; konec souboru

         mov       bx,ds:[SoubDbf]
         mov       dx,offset Zaznam0
         mov       cx,ds:[ZaznByte]         ; dlka zznamu
         mov       ah,40h
         int       21h                      ; zpis dat
         jc        Start882                 ; chyba zpisu
         cmp       ax,cx
         jne       Start882                 ; disk pln

         add       word ptr ds:[PocVet],1   ; zven tae vt
         adc       word ptr ds:[PocVet+2],0
         jmp       short Start9

; ------ zpis EOF na konec souboru

Start96: mov       dx,offset Eof
         mov       cx,1
         mov       bx,ds:[SoubDbf]
         mov       ah,40h
         int       21h

; ------ zpis novho zhlav

         xor       cx,cx
         xor       dx,dx
         mov       ax,4200h
         int       21h

         mov       cx,32                    ; velikost zhlav
         mov       ah,40h
         mov       dx,offset HeadDbf        ; zhlav
         int       21h                      ; zpis zhlav souboru
         jc        Start882

; ------ uzaven soubor

Start98: mov       bx,ds:[SoubDef]
         or        bx,bx
         jz        Start99                  ; nebyl oteven
         mov       ah,3eh
         int       21h                      ; uzaven souboru
Start99: mov       bx,ds:[SoubDat]
         mov       ah,3eh
         int       21h
         mov       bx,ds:[SoubDbf]
         mov       ah,3eh
         int       21h
         int       20h

; -----------------------------------------------------------------------------
;        naten dku ze souboru BX do bufferu (ES) DS:DI (CY=konec)
; -----------------------------------------------------------------------------

ReadLine PROC      NEAR

; ------ naten maxima dat

         mov       bp,di                    ; BP <- adresa zatku bufferu
         mov       dx,di                    ; buffer dku
         mov       ah,3fh
         mov       cx,300                   ; poet bajt
         int       21h                      ; naten obsahu bufferu
         jnc       ReadLin1
         xor       ax,ax                    ; pi chyb konec
ReadLin1:xchg      ax,cx                    ; CX <- poet natench bajt
         stc                                ; pznak chyby
         jcxz      ReadLin9                 ; nebylo nic nateno - konec

; ------ nalezen konce dat LF s vyputnm vech CR a EOF

         mov       si,di                    ; buffer dku
         cld
ReadLin2:lodsb                              ; naten znaku
         cmp       al,26
         je        ReadLin3                 ; EOF se ignoruje
         cmp       al,13
         je        ReadLin3                 ; CR se ignoruje
         cmp       al,10
         je        ReadLin4                 ; konec dku LF
         stosb                              ; uloen znaku
ReadLin3:loop      ReadLin2                 ; dal znak

; ------ nvrat ukazatele souboru o pebytek dku zpt

         inc       cx
ReadLin4:dec       cx                       ; korekce ukazatele
         jz        ReadLin5
         mov       dx,cx                    ; pebytek dku LOW
         neg       dx                       ; zporn offset
         mov       cx,-1                    ; pebytek dku HIGH
         mov       ax,4201h
         int       21h                      ; nvrat ukazatele v souboru

; ------ vymazn zbytku dku

ReadLin5:mov       cx,bp                    ; adresa zatku dku
         add       cx,300                   ; konec bufferu
         sub       cx,di                    ; zbytek dku
         mov       al," "                   ; mazac mezera
         cld
         rep       stosb                    ; vymazn zbytku dku

         clc                                ; pznak operace OK
ReadLin9:ret

ReadLine ENDP

; -----------------------------------------------------------------------------
;        Data
; -----------------------------------------------------------------------------
;
SoubDef  dw        0                        ; identifiktor defininho souboru
SoubDat  dw        0                        ; identifiktor vstupnho souboru
SoubDbf  dw        0                        ; identifiktor vstupnho souboru

Eof      db        1ah                      ; pznak konce souboru

UvTxt    db        'SEZNDBF V1.0 - konverze seznamu do DBF; (c) Miroslav Nemecek',13,10,'$'

NeniTxt  db        'Zadany vstupni soubor DAT nenalezen !',13,10
HelpTxt  db        '  Zadejte JMENO souboru seznamu ke konverzi do DBF.',13,10
         db        '  Bude zkonvertovan soubor JMENO.DAT s definici JMENO.DEF',13,10
         db        '  do vystupniho souboru JMENO.DBF.',13,10,'$'

ExistTxt db        'Vystupni soubor DBF jiz existuje !',13,10,'$'
MemTxt   db        'Nedostatek pameti k provedeni konverze !',13,10,'$'
WritTxt  db        'Chyba zapisu do vystupniho souboru DBF !',13,10,'$'

Nadpis   db        300 dup(" ")             ; nadpis
Maska    db        300 dup("#")             ; maska

Zaznam0  db        ' '                      ; pznak zruen poloky
Zaznam   db        300 dup(" ")             ; buffer jednoho zznamu

JmenPol  dw        '0A'                     ; ukazatel sel poloek

; ------ zhlav souboru DBF

HeadDBF  label     byte
Verze    db        3                        ; 0: verze databze
Rok      db        0                        ; 1: rok
Mesic    db        1                        ; 2: msc
Den      db        1                        ; 3: den
PocVet   dd        0                        ; 4: poet vt
HeadByte dw        33                       ; 8: velikost zhlav (bajt)
ZaznByte dw        1                        ; 0Ah: dlka zznamu (bajt)
         db        20 dup(0)                ; 0Ch:  ... rezervovno
TabPopis label     byte                     ; 20h: tabulka popisova

; Popisova (kad 32 bajt, za poslednm popisovaem je 0Dh):
;             0 (11) jmno poloky ASCIIZ (s 0 na konci)
;            11 (1) typ poloky (C, N, F, L, D nebo M)
;                          typ C (Character): text doplnn zprava mezerami
;                                             dlka max. 254 znak
;                          typ N (Numeric): slo s pevnou desetinnou tekou,
;                                           znaky "0" a "9","-", "+" a "."
;                                           max. 20 pozic (max. 15 des. mst)
;                          typ F (Float): reln slo s pohyblivou tekou,
;                                           max. 20 pozic (max. 15 des. mst),
;                                           rozsah 0.9xE+308 a 0.1xE-307,
;                                           max. 15 slic ped tekou a 9 za
;                          typ L (Logical): hodnoty Y,y,N,n,T,t,F,f,mezera
;                          typ D (Date): osum slic RRRRMMDD
;                          typ M (Memo): deset slic - slo potenho bloku
;                                        .DBT textu k poloce
;                          typ P (Picture): (pouze FOXPRO)
;            12 (4) adresa obsahu poloky v pamti
;            16 (1) dlka poloky v zznamu (bajt)
;            17 (1) poet desetinnch mst
;            18 (2) ... rezervovno
;            20 (1) oznaen pracovn oblasti
;            21 (2) ... rezervovno
;            23 (1) nvt pro SET FIELDS TO (...)
;            24 (8) ... rezervovno
;
; zznam:     0 (1) pznak zruen poloky - "*"=zruen, jinak " "
;             1 (x) poloky (nsleduj bezprostedn za sebou)

Code     ENDS
         END       Start
